package com.zcloud.controller.onlinexxks;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.service.onlinexxks.StageExamPaperInputQuestionService;
import com.zcloud.service.onlinexxks.StageexampaperInputService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：阶段试卷表
 * 作者：luoxiaobao
 * 时间：2021-12-17
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/stageexampaperinput")
public class StageexampaperInputController extends BaseController {

	@Autowired
	private StageexampaperInputService stageexampaperinputService;
	@Autowired
	private StageExamPaperInputQuestionService stageExamPaperInputQuestionService;
	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	@RequiresPermissions( value = {"stageexampaper:add", "curriculum:add"}, logical = Logical.OR)
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String date = DateUtil.date2Str(new Date());
		pd.put("STAGEEXAMPAPERINPUT_ID", this.get32UUID());	//主键
		pd.put("CREATOR", Jurisdiction.getUsername());	//添加人
		pd.put("CREATTIME", date);	//添加时间
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", date);	//修改时间
		pd.put("EXAMSTATE", "0");	//试卷状态(0:初始 1：已考试)
		pd.put("ISDELETE", "0");	//是否删除(0:有效 1：删除)
		pd.put("STATE", "0");	//
		List<PageData> saveStageList = stageexampaperinputService.getSaveStage(pd);
		if(null != saveStageList){
			stageexampaperinputService.save(pd);
			stageExamPaperInputQuestionService.saveAll(pd, saveStageList);
		}else{
			errInfo = "false";
			map.put("msg", "培训行业类型或岗位培训类型对应的习题数量不足，无法生成试卷，请重新选择！");
		}
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	@RequiresPermissions( value = {"stageexampaper:del", "curriculum:del"}, logical = Logical.OR)
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		stageexampaperinputService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	@RequiresPermissions( value = {"stageexampaper:edit", "curriculum:edit"}, logical = Logical.OR)
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		stageexampaperinputService.edit(pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	@RequiresPermissions( value = {"stageexampaper:list", "curriculum:list"}, logical = Logical.OR)
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = stageexampaperinputService.list(page);	//列出StageexampaperInput列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	@RequiresPermissions( value = {"stageexampaper:edit", "curriculum:edit"}, logical = Logical.OR)
	@ResponseBody
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());
		pd = stageexampaperinputService.findById(pd);	//根据ID读取
		List<PageData> inputQue = stageExamPaperInputQuestionService.listAllAndQuestion(pd); //根据试卷id获取生成的习题
		map.put("inputQue", inputQue);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	@RequiresPermissions( value = {"stageexampaper:del", "curriculum:del"}, logical = Logical.OR)
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String ArrayDATA_IDS[] = DATA_IDS.split(",");
			stageexampaperinputService.deleteAll(ArrayDATA_IDS);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	@RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("备注1");	//1
		titles.add("试卷名称");	//2
		titles.add("培训行业类型");	//3
		titles.add("岗位培训类型");	//4
		titles.add("试卷分数");	//5
		titles.add("合格分数");	//6
		titles.add("多选题数");	//7
		titles.add("多选分值");	//8
		titles.add("单选题数");	//9
		titles.add("单选题数");	//10
		titles.add("判断题数");	//11
		titles.add("判断题数");	//12
		titles.add("试卷状态");	//13
		titles.add("添加人");	//14
		titles.add("添加时间");	//15
		titles.add("修改人");	//16
		titles.add("修改时间");	//17
		titles.add("是否删除(0:有效 1：删除)");	//18
		titles.add("企业ID");	//19
		dataMap.put("titles", titles);
		List<PageData> varOList = stageexampaperinputService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("STAGEEXAMPAPERINPUT_ID"));	    //1
			vpd.put("var2", varOList.get(i).getString("EXAMNAME"));	    //2
			vpd.put("var3", varOList.get(i).getString("TRAINTYPE"));	    //3
			vpd.put("var4", varOList.get(i).getString("POSTTYPE"));	    //4
			vpd.put("var5", varOList.get(i).getString("EXAMSCORE"));	    //5
			vpd.put("var6", varOList.get(i).getString("PASSSCORE"));	    //6
			vpd.put("var7", varOList.get(i).getString("DUOXUANTICOUNT"));	    //7
			vpd.put("var8", varOList.get(i).get("DUOXUANTINUMBER").toString());	//8
			vpd.put("var9", varOList.get(i).getString("DANYUANTICOUNT"));	    //9
			vpd.put("var10", varOList.get(i).get("DANXUANTINUMBER").toString());	//10
			vpd.put("var11", varOList.get(i).getString("PANDUITICOUNT"));	    //11
			vpd.put("var12", varOList.get(i).get("PANDUITINUMBER").toString());	//12
			vpd.put("var13", varOList.get(i).getString("EXAMSTATE"));	    //13
			vpd.put("var14", varOList.get(i).getString("CREATOR"));	    //14
			vpd.put("var15", varOList.get(i).getString("CREATTIME"));	    //15
			vpd.put("var16", varOList.get(i).getString("OPERATOR"));	    //16
			vpd.put("var17", varOList.get(i).getString("OPERATTIME"));	    //17
			vpd.put("var18", varOList.get(i).get("ISDELETE").toString());	//18
			vpd.put("var19", varOList.get(i).getString("CORPINFO_ID"));	    //19
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}
	/**通过试卷ID获取阶段试卷相关数据（试卷、试卷试题）
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/getExam")
//	@RequiresPermissions( value = {"coursepapers:edit", "curriculum:edit"}, logical = Logical.OR)
	@ResponseBody
	public Object getExam() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
//		pd = stageExamPaperInputQuestionService.getExam(pd);	//通过试卷ID获取数据
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/editState")
	@RequiresPermissions( value = {"stageexampaper:edit", "curriculum:edit"}, logical = Logical.OR)
	@ResponseBody
	public Object editState() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//操作人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//操作时间
		stageexampaperinputService.editState(pd);
		map.put("result", errInfo);
		return map;
	}
}
